const parametrizacoes = require('../../model/parametrizacoes');
const adqGetDashboardFiliais = require('../../model/adqGetDashboardFiliais');
const routesParams = ['parametrizacoes', 'parametrizacoesFilial'];
const apiController = require('../../controller/ApiController');

const route = (router) => {
  router.get('/data/*', ((req, res) => {
    /** Tipo de conexões dos monitoramentos */
    if (req.path.split('/')[2] === 'connect') {
      let conexao = [];
      let ave = [];
  
      /** Rota simples */
      if (req.query.obj !== undefined && req.query.obj !== 'monitoring') {
        watch.getAll({ NOME: req.query.obj })
          .then((a => {
            res.send(a.rows[0][3]);
          })).catch((() => {
            res.send('Component não registrado.');
          }));
      }
      /** Conexões da Home, lista todas e retorna */
      else {
        watch.getConexao({ NAVEGACAO: 'component' })
          .then((a => {
            conexao = a.rows[0][0];
            ave = JSON.parse(conexao).conexao;
            
            /** As conexões filhos */
            watch.getConexao({ NAVEGACAO: 'monitoring' })
              .then((a => {
                a.rows.forEach((element) => {
                  const conect = JSON.parse(element[0]).conexao[1];
                  ave.push(conect);
                });
                const rest = JSON.parse(conexao);
                rest.conexao = ave;
                res.send(rest);
  
              })).catch((() => {
                res.send('Component não registrado.');
              }));
  
          })).catch((() => {
            res.send('Component não registrado.');
          }));
      }
    } else if (routesParams.includes(req.path.split('/')[2])) { // Rotas Parametrizacoes
        if (req.path.split('/')[2] === routesParams[0]) { // Parametrizações Gerais
          parametrizacoes.getAssConfig().then((a) => {
            const params = { 
              data: [],
              pagination: {
                limit: 999,
                total: a.rows.length
              }
            };
            a.rows.forEach((element) => {
              params.data.push({
                ID:        element[0].toString(),
                NOME:      element[1],
                DESCRICAO: element[2],
                TIPO:      element[3],
                ORDEM:     element[4],
                ATIVO:     element[5],
                COMANDO:   element[6],
                INTERVALO:   element[7]
              });
            });
            res.send(params);
          }).catch(() => {
            res.send('Erro ao buscar os components.');
          });
        }
        else { //Parametrizações por Filial
          parametrizacoes.getFilial().then((a) => {
            const params = {
              data: [],
              pagination: {
                limit: 999,
                total: a.rows.length
              }
            };
            a.rows.forEach((element) => {
              params.data.push({
                CDFILIAL:     element[0],
                NMFILIAL:     element[1]
              });
            });
            res.send(params);
          }).catch(() => {
            res.status(500).send('Erro ao buscar os components. Error: ' + error.message);
          });
        }
    } else if (req.path.split('/')[2] === 'monitoring') {
      adqGetDashboardFiliais.get().then((a) => {
        const params = { 
          data: [],
          pagination: {
            limit: 10,
            total: a.rows.length
          }
        };
        a.rows.forEach((element) => {
          params.data.push({
            id:   element[0],
            name: element[1]
          });
        });
        res.send(params);
      }).catch(() => {
        res.send('Erro ao buscar os components.');
      });    
    } else if (req.path.split('/')[2] === 'orgProducts') {
      apiController.getOrgProducts().then((a) => {
        res.send(a);
      }).catch((error) => {
        res.send(error);
      });
    } else {
      watch.getAll({ NOME: req.path.split('/')[2] })
        .then((a) => {
          /** Se for o monitoring, busque as informações de Colunas */
          if (a.rows[0][1] === 'monitoring') {
            const componente = JSON.parse(a.rows[0][2]).children[0].children[0].columns;
            watch.getNav()
              .then((colunas) => {
                if (colunas.rows.length > 0) {
                  colunas.rows.forEach((col) => {
                    componente.push(JSON.parse(col[0]));
                  });
                }
                const novoComponent = JSON.parse(a.rows[0][2]);
                novoComponent.children[0].children[0].columns = componente;
                res.send(novoComponent);
              });
          } else {
            res.send(a.rows[0][2]);
          }
        }).catch((error) => {
          res.send('Component não registrado.');
        });
    }
  }));
}

module.exports = route;