class ProductModel {
    constructor() {
        this.FETCH_PROMO_PRODUCTS = `
        SELECT
        *
        FROM (
            SELECT
                -- CDPRODPROMOCAO
                ITM.NRBUTTON,
                ITM.NRPGCONFTELA,
                ITM.DSBUTTON,
                GPP.CDPRODPROMOCAO,
                GPP.CDGRUPMUTEXFIL AS CDGRUPMUTEX,
                GPP.QTPRGRUPROMINFIL AS QTPRGRUPROMIN,
                GPP.QTPRGRUPPROMFIL AS QTPRGRUPPROMOC,
                GPP.NRORDPROMOGRUPFIL AS NRORDPROMOGRUP,
                PROD.CDPRODUTO,
                PROD.CDGRUPROMOC,
                GPM.DSGROUPTAA,
                GPM.IDMODOEXIBETAA,
                GPM.NMGRUPROMOC,
                PROD_GERAL.NMPRODUTO,
                PROD_GERAL.CDBARPRODUTO,
                PROD_GERAL.DSPRODVENDA,
                PROD_GERAL.IDPESAPROD,
                PROD_GERAL.IDTIPOCOMPPROD,
                PROD_GERAL.IDIMPPRODUTO,
                PROD.DSENDEIMGPROMO AS DSENDEIMG,

                -- CASES PROD & FIL --
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDPERVALORDES, 'P')
                ELSE DSFIL.IDPERVALDESFIL
                END AS IDPERVALORDES,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN DS.VRDESPRODPROMOC
                ELSE DSFIL.VRDESPRPROMOFIL
                END AS VRDESPRODPROMOC,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDAPLICADESCPR, 'T')
                ELSE DSFIL.IDAPLICADESCPRFI
                END AS IDAPLICADESCPR,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDPRODPRESELEC, 'N')
                ELSE DSFIL.IDPRODPRESELFIL
                END AS IDPRODPRESELEC,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDOBRPRODSELEC, 'N')
                ELSE DSFIL.IDOBRPRODSELFIL
                END AS IDOBRPRODSELEC,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDDESCACRPROMO, 'N')
                ELSE DSFIL.IDDESCACRPROFIL
                END AS IDDESCACRPROMO,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDPRINCPROD, 'N')
                ELSE DSFIL.IDPRINCPROD
                END AS IDPRINCPROD,

                -- DTULTATU
                ITM.DTULTATUITCT,
                PROD.DTULTATUPRPRC,
                PROD_GERAL.DTULTATUPROD,
                GPM.DTULTATUGPPRC,
                GPP.DTULTATUGRPRFIL AS DTULTATUGRPROPR,
                DS.DTULTATUDESPR,
                DSFIL.DTULTATUDESPRFI,

                -- PRECOS
                CAST((PRECO_GERAL.VRPRECITEM) AS float) AS VRPRECITEM,
                PRECO_DIA.VRPRECODIA AS DIFF_PRICE,
                PRECO_DIA.CDTIPOCONSPD,
                PRECO_DIA.HRINIPRECDIA,
                PRECO_DIA.HRFINPRECDIA,
                PRECO_DIA.IDVISUACUPOM,
                PRECO_DIA.IDPERVALORPR,
                PRECO_DIA.IDDESCACREPR
                
            FROM ITMENUCONFTE ITM
            JOIN GRUPROMOCPRFIL GPP ON GPP.CDPRODPROMOCAO = ITM.CDIDENTBUTON
                AND GPP.CDFILIAL = ITM.CDFILIAL
            JOIN GRUPROMOC GPM ON GPM.CDGRUPROMOC = GPP.CDGRUPROMOC
            JOIN PRODGRUPROMOC PROD ON PROD.CDGRUPROMOC = GPM.CDGRUPROMOC
            JOIN PRODUTO PROD_GERAL ON PROD_GERAL.CDPRODUTO = PROD.CDPRODUTO
            LEFT JOIN DESGRUPROMOCPR DS ON DS.CDGRUPROMOC = PROD.CDGRUPROMOC
                AND DS.CDPRODUTO = PROD.CDPRODUTO
                AND DS.CDPRODPROMOCAO = GPP.CDPRODPROMOCAO
            LEFT JOIN DESGRUPROMPRFIL DSFIL ON DSFIL.CDGRUPROMOC = PROD.CDGRUPROMOC
                AND DSFIL.CDPRODUTO = PROD.CDPRODUTO
                AND DSFIL.CDPRODPROMOCAO = GPP.CDPRODPROMOCAO
                AND ITM.CDFILIAL = DSFIL.CDFILIAL
            LEFT JOIN ALIQIMPFIS AL ON AL.CDFILIAL = :CDFILIAL
                AND AL.CDPRODUTO = PROD.CDPRODUTO
            LEFT JOIN PRODBLOQVND PB ON PB.CDFILIAL = :CDFILIAL
                AND PB.CDLOJA = :CDLOJA
                AND PB.CDPRODUTO = PROD.CDPRODUTO
                AND (
                PB.NRDIASEMANABLOQ = 'T'
                OR PB.NRDIASEMANABLOQ = :NRDIASEMANABLOQ
                )
            JOIN ITEMPRECO PRECO_GERAL ON PRECO_GERAL.CDPRODUTO = PROD_GERAL.CDPRODUTO
                AND PRECO_GERAL.CDTABEPREC = :CDTABEPREC
                AND PRECO_GERAL.DTINIVGPREC = CONVERT(DATETIME, :DTINIVGPREC, 120) 
                -- AND PRECO_GERAL.DTINIVGPREC = :DTINIVGPREC
            LEFT JOIN ITEMPRECODIA PRECO_DIA ON PRECO_DIA.CDFILIAL = :CDFILIAL
                AND PRECO_DIA.CDPRODUTO = PRECO_GERAL.CDPRODUTO
                AND PRECO_DIA.CDFILIAL = PRECO_GERAL.CDFILIAL
                AND PRECO_DIA.CDTABEPREC = PRECO_GERAL.CDTABEPREC
                AND PRECO_DIA.CDTABEPREC = :CDTABEPREC
                AND PRECO_DIA.DTINIVGPREC = CONVERT(DATETIME, :DTINIVGPREC, 120) 
                -- AND PRECO_DIA.DTINIVGPREC = :DTINIVGPREC
                AND (
                (PRECO_DIA.NRDIASEMANPR = :NRDIASEMANPR)
                OR (PRECO_DIA.NRDIASEMANPR = 'T')
                )
                AND :HORA BETWEEN PRECO_DIA.HRINIPRECDIA
                AND PRECO_DIA.HRFINPRECDIA
                AND GETDATE() BETWEEN PRECO_DIA.DTINIVALPREC
                AND PRECO_DIA.DTFINVALPREC
                AND (
                PRECO_DIA.CDTIPOCONSPD = null
                OR PRECO_DIA.CDTIPOCONSPD = 'T'
                )

            WHERE
                ITM.IDATIVO <> 'N'
                AND ITM.IDTPBUTTON = '1'
                AND ITM.NRCONFTELA = :NRCONFTELA
                AND ITM.CDFILIAL = :CDFILIAL 
                --AND GPP.CDPRODPROMOCAO = '9050100100'
                --AND ITM.DSBUTTON LIKE '%ACEBOLADO%'
                --AND ITM.DSBUTTON LIKE '%P1C%'
            UNION
            SELECT
                -- CDPRODPROMOCAO
                ITM.NRBUTTON,
                ITM.NRPGCONFTELA,
                ITM.DSBUTTON,
                GPP.CDPRODPROMOCAO,
                GPP.CDGRUPMUTEX,
                GPP.QTPRGRUPROMIN,
                GPP.QTPRGRUPPROMOC,
                GPP.NRORDPROMOGRUP AS NRORDPROMOGRUP,
                PROD.CDPRODUTO,
                PROD.CDGRUPROMOC,
                GPM.DSGROUPTAA,
                GPM.IDMODOEXIBETAA,            
                GPM.NMGRUPROMOC,
                PROD_GERAL.NMPRODUTO,
                PROD_GERAL.CDBARPRODUTO,
                PROD_GERAL.DSPRODVENDA,
                PROD_GERAL.IDPESAPROD,
                PROD_GERAL.IDTIPOCOMPPROD,
                PROD_GERAL.IDIMPPRODUTO,
                PROD.DSENDEIMGPROMO AS DSENDEIMG,
                -- CASES PROD & FIL --
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDPERVALORDES, 'P')
                ELSE DSFIL.IDPERVALDESFIL
                END AS IDPERVALORDES,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN DS.VRDESPRODPROMOC
                ELSE DSFIL.VRDESPRPROMOFIL
                END AS VRDESPRODPROMOC,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDAPLICADESCPR, 'T')
                ELSE DSFIL.IDAPLICADESCPRFI
                END AS IDAPLICADESCPR,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDPRODPRESELEC, 'N')
                ELSE DSFIL.IDPRODPRESELFIL
                END AS IDPRODPRESELEC,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDOBRPRODSELEC, 'N')
                ELSE DSFIL.IDOBRPRODSELFIL
                END AS IDOBRPRODSELEC,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDDESCACRPROMO, 'N')
                ELSE DSFIL.IDDESCACRPROFIL
                END AS IDDESCACRPROMO,
                CASE
                WHEN DSFIL.CDPRODPROMOCAO IS NULL THEN ISNULL(DS.IDPRINCPROD, 'N')
                ELSE DSFIL.IDPRINCPROD
                END AS IDPRINCPROD,
                -- DTULTATU
                ITM.DTULTATUITCT,
                PROD.DTULTATUPRPRC,
                PROD_GERAL.DTULTATUPROD,
                GPM.DTULTATUGPPRC,
                GPP.DTULTATUGRPROPR,
                DS.DTULTATUDESPR,
                DSFIL.DTULTATUDESPRFI,
                -- PRECOS
                CAST((PRECO_GERAL.VRPRECITEM) AS float) AS VRPRECITEM,
                PRECO_DIA.VRPRECODIA AS DIFF_PRICE,
                PRECO_DIA.CDTIPOCONSPD,
                PRECO_DIA.HRINIPRECDIA,
                PRECO_DIA.HRFINPRECDIA,
                PRECO_DIA.IDVISUACUPOM,
                PRECO_DIA.IDPERVALORPR,
                PRECO_DIA.IDDESCACREPR
            FROM ITMENUCONFTE ITM
            JOIN GRUPROMOCPROD GPP ON GPP.CDPRODPROMOCAO = ITM.CDIDENTBUTON
            JOIN GRUPROMOC GPM ON GPM.CDGRUPROMOC = GPP.CDGRUPROMOC
            JOIN PRODGRUPROMOC PROD ON PROD.CDGRUPROMOC = GPM.CDGRUPROMOC
            JOIN PRODUTO PROD_GERAL ON PROD_GERAL.CDPRODUTO = PROD.CDPRODUTO
            LEFT JOIN DESGRUPROMOCPR DS ON DS.CDGRUPROMOC = PROD.CDGRUPROMOC
                AND DS.CDPRODUTO = PROD.CDPRODUTO
                AND DS.CDPRODPROMOCAO = GPP.CDPRODPROMOCAO
            LEFT JOIN DESGRUPROMPRFIL DSFIL ON DSFIL.CDGRUPROMOC = PROD.CDGRUPROMOC
                AND DSFIL.CDPRODUTO = PROD.CDPRODUTO
                AND DSFIL.CDPRODPROMOCAO = GPP.CDPRODPROMOCAO
                AND ITM.CDFILIAL = DSFIL.CDFILIAL
            LEFT JOIN ALIQIMPFIS AL ON AL.CDFILIAL = :CDFILIAL
                AND AL.CDPRODUTO = PROD.CDPRODUTO
            LEFT JOIN PRODBLOQVND PB ON PB.CDFILIAL = :CDFILIAL
                AND PB.CDLOJA = :CDLOJA
                AND PB.CDPRODUTO = PROD.CDPRODUTO
                AND (
                PB.NRDIASEMANABLOQ = 'T'
                OR PB.NRDIASEMANABLOQ = :NRDIASEMANABLOQ
                )
            JOIN ITEMPRECO PRECO_GERAL ON PRECO_GERAL.CDPRODUTO = PROD_GERAL.CDPRODUTO
                AND PRECO_GERAL.CDTABEPREC = :CDTABEPREC
                AND PRECO_GERAL.DTINIVGPREC = CONVERT(DATETIME, :DTINIVGPREC, 120) 
                --AND PRECO_GERAL.DTINIVGPREC = :DTINIVGPREC
            LEFT JOIN ITEMPRECODIA PRECO_DIA ON PRECO_DIA.CDFILIAL = :CDFILIAL
                AND PRECO_DIA.CDTABEPREC = :CDTABEPREC
                AND PRECO_DIA.DTINIVGPREC = CONVERT(DATETIME, :DTINIVGPREC, 120) 
                --AND PRECO_DIA.DTINIVGPREC = :DTINIVGPREC
                AND (
                (PRECO_DIA.NRDIASEMANPR = :NRDIASEMANPR)
                OR (PRECO_DIA.NRDIASEMANPR = 'T')
                )
                AND :HORA BETWEEN PRECO_DIA.HRINIPRECDIA
                AND PRECO_DIA.HRFINPRECDIA
                AND GETDATE() BETWEEN PRECO_DIA.DTINIVALPREC
                AND PRECO_DIA.DTFINVALPREC
                AND (
                PRECO_DIA.CDTIPOCONSPD = null
                OR PRECO_DIA.CDTIPOCONSPD = 'T'
                )
                AND PRECO_DIA.CDPRODUTO = PRECO_GERAL.CDPRODUTO
                AND PRECO_DIA.CDFILIAL = PRECO_GERAL.CDFILIAL
                AND PRECO_DIA.CDTABEPREC = PRECO_GERAL.CDTABEPREC
            WHERE
                ITM.IDATIVO <> 'N'
                AND ITM.IDTPBUTTON = '1'
                AND ITM.NRCONFTELA = :NRCONFTELA
                AND ITM.CDFILIAL = :CDFILIAL
                AND GPP.CDPRODPROMOCAO NOT IN (
                SELECT
                    -- CDPRODPROMOCAO
                    DISTINCT GPP.CDPRODPROMOCAO
                FROM ITMENUCONFTE ITM
                JOIN GRUPROMOCPRFIL GPP ON GPP.CDPRODPROMOCAO = ITM.CDIDENTBUTON
                    AND GPP.CDFILIAL = ITM.CDFILIAL
                JOIN GRUPROMOC GPM ON GPM.CDGRUPROMOC = GPP.CDGRUPROMOC
                JOIN PRODGRUPROMOC PROD ON PROD.CDGRUPROMOC = GPM.CDGRUPROMOC
                JOIN PRODUTO PROD_GERAL ON PROD_GERAL.CDPRODUTO = PROD.CDPRODUTO
                LEFT JOIN DESGRUPROMOCPR DS ON DS.CDGRUPROMOC = PROD.CDGRUPROMOC
                    AND DS.CDPRODUTO = PROD.CDPRODUTO
                    AND DS.CDPRODPROMOCAO = GPP.CDPRODPROMOCAO
                LEFT JOIN DESGRUPROMPRFIL DSFIL ON DSFIL.CDGRUPROMOC = PROD.CDGRUPROMOC
                    AND DSFIL.CDPRODUTO = PROD.CDPRODUTO
                    AND DSFIL.CDPRODPROMOCAO = GPP.CDPRODPROMOCAO
                    AND ITM.CDFILIAL = DSFIL.CDFILIAL
                LEFT JOIN ALIQIMPFIS AL ON AL.CDFILIAL = :CDFILIAL
                    AND AL.CDPRODUTO = PROD.CDPRODUTO
                LEFT JOIN PRODBLOQVND PB ON PB.CDFILIAL = :CDFILIAL
                    AND PB.CDLOJA = :CDLOJA
                    AND PB.CDPRODUTO = PROD.CDPRODUTO
                    AND (
                    PB.NRDIASEMANABLOQ = 'T'
                    OR PB.NRDIASEMANABLOQ = :NRDIASEMANABLOQ
                    )
                JOIN ITEMPRECO PRECO_GERAL ON PRECO_GERAL.CDPRODUTO = PROD_GERAL.CDPRODUTO
                    AND PRECO_GERAL.CDTABEPREC = :CDTABEPREC
                    AND PRECO_GERAL.DTINIVGPREC = CONVERT(DATETIME, :DTINIVGPREC, 120) -- AND PRECO_GERAL.DTINIVGPREC = :DTINIVGPREC
                LEFT JOIN ITEMPRECODIA PRECO_DIA ON PRECO_DIA.CDFILIAL = :CDFILIAL
                    AND PRECO_DIA.CDTABEPREC = :CDTABEPREC
                    AND PRECO_DIA.DTINIVGPREC = CONVERT(DATETIME, :DTINIVGPREC, 120) -- AND PRECO_DIA.DTINIVGPREC = :DTINIVGPREC
                    AND (
                    (PRECO_DIA.NRDIASEMANPR = :NRDIASEMANPR)
                    OR (PRECO_DIA.NRDIASEMANPR = 'T')
                    )
                    AND :HORA BETWEEN PRECO_DIA.HRINIPRECDIA
                    AND PRECO_DIA.HRFINPRECDIA
                    AND GETDATE() BETWEEN PRECO_DIA.DTINIVALPREC
                    AND PRECO_DIA.DTFINVALPREC
                    AND (
                    PRECO_DIA.CDTIPOCONSPD = null
                    OR PRECO_DIA.CDTIPOCONSPD = 'T'
                    )
                    AND PRECO_DIA.CDPRODUTO = PRECO_GERAL.CDPRODUTO
                    AND PRECO_DIA.CDFILIAL = PRECO_GERAL.CDFILIAL
                    AND PRECO_DIA.CDTABEPREC = PRECO_GERAL.CDTABEPREC
                WHERE
                    ITM.IDATIVO <> 'N'
                    AND ITM.IDTPBUTTON = '1'
                    AND ITM.NRCONFTELA = :NRCONFTELA
                    AND ITM.CDFILIAL = :CDFILIAL 
                    --AND GPP.CDPRODPROMOCAO = '9050100100'
                    --AND ITM.DSBUTTON LIKE '%ACEBOLADO%'
                    --AND ITM.DSBUTTON LIKE '%P1C%'
                )
            ) TABLEA --ORDER BY DSBUTTON
        ORDER BY
            NRBUTTON,
            NRPGCONFTELA,
            DSBUTTON,
            CDPRODPROMOCAO,
            NRORDPROMOGRUP,
            CDGRUPMUTEX,
            VRPRECITEM
        `;
    };

    getPromoProducts(app, params) {
        return app.service.OracleConnection.connect().then(sql => {
            return app.service.OracleConnection.fetch(this.FETCH_PROMO_PRODUCTS, params);
        })
    }
}

module.exports = new ProductModel();