const OracleService = require('../service/OracleService');

class saleModel {
  constructor() {
    /** São mais de uma loja por filial */

    /**
     * O pedido delivery tem o prefixo "DLV_" no campo DSCOMANDA.
     * Daniel Rosa disse para subistituir o
     * INNER JOIN VENDAREST VR ON VR.NRVENDAREST = V.NRCOMANDAVND
     * Para
     * INNER JOIN VENDAREST VR ON VR.NRVENDARESTAUX = V.NRVENDAREST
     */
    this.GET_SALES_DELIVERY = `
    SELECT C.CDFILIAL AS id, C.DSCOMANDA, TO_CHAR(V.DTHRABERMESA, 'DD/MM/YYYY HH24:MI:SS') AS DTHRABERMESA, 
           C.NRCOMANDA, C.CDLOJA, L.NMLOJA, V.IDSINCMSDE
      FROM COMANDAVEN C
      JOIN VENDAREST V
        ON C.CDFILIAL = V.CDFILIAL
       AND C.NRVENDAREST = V.NRVENDAREST
      JOIN LOJA L
        ON C.CDFILIAL = L.CDFILIAL
       AND C.CDLOJA = L.CDLOJA
     WHERE C.DSCOMANDA LIKE 'DLV%'
       AND V.DTHRABERMESA >= (SYSDATE - INTERVAL '2' HOUR)
       AND V.IDSINCMSDE = 'N'
       AND C.CDFILIAL = :CDFILIAL
     ORDER BY DTHRABERMESA DESC
    `;

    this.GET_SALES_DELIVERY_MONITORING = `
    SELECT C.CDFILIAL, COUNT(*) AS COUNT
      FROM COMANDAVEN C
      JOIN VENDAREST V ON C.CDFILIAL = V.CDFILIAL
       AND C.NRVENDAREST = V.NRVENDAREST
     WHERE C.DSCOMANDA LIKE 'DLV%'
       AND V.DTHRABERMESA >= (SYSDATE - INTERVAL '4' HOUR)
       AND V.IDSINCMSDE = 'N'
     GROUP BY C.CDFILIAL  
    `;

    this.GET_FILIAL = `      
      SELECT F.CDFILIAL, F.NMFILIAL
        FROM FILIAL F
       WHERE UPPER(F.NMFILIAL) NOT LIKE '%INAT%' 
       GROUP BY F.CDFILIAL, F.NMFILIAL
       ORDER BY F.CDFILIAL
    `;


    // AND  V.DTVENDA LIKE '%09/20'
    /** Mesa e comanda
    * Os campos que indicam que o pedido esta pendente são: IDSINCMSDE = 'N', NRVENDARESTAUX = NULL
    */
    this.GET_SALES_MC = `
      SELECT CDFILIAL AS id, NRVENDAREST, IDSINCMSDE, NRVENDARESTAUX FROM VENDAREST
    `;

    this.GET_SALES_ALL = `
      SELECT CDFILIAL AS id, VENDA.*
      FROM VENDA
      WHERE IDIMPVENDA <> 'S'
      AND ROWNUM >= :MIN_ROW;
    `;
    // AND DTVENDA LIKE '%09/20'
    /** Qualquer venda que não subiu
     * SELCT * FROM VENDA WHERE IDIMPVENDA <> 'S'
     */
  }

  getDelivery(params) {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_SALES_DELIVERY, params);
    });
  }

  getDeliveryMonitoring() {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_SALES_DELIVERY_MONITORING);
    });
  }

  getMC() {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_SALES_MC);
    });
  }

  getAll(params) {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_SALES_ALL, params);
    });
  }

  getFilial() {
    return OracleService.connect().then(() => {
      return OracleService.execute(this.GET_FILIAL);
    });
  }
}

module.exports = new saleModel();
