const OracleService = require('../service/OracleService');

class updaterHistoricoModel 
{
  getUpdaterProdutoHistorico(cdProductId, cdFilial) {
    const sql = `
    SELECT H.CDFILIAL, F.NMFILIAL, H.CDFILIAL || ' - ' || F.NMFILIAL AS FILIAL,
           H.CDUUID, H.CDPRODUCTID, P.NMPRODUCT, H.IDSTEVENTO,
           NVL(H.NRVERSAOATUAL, '-') AS NRVERSAOATUAL, H.NRVERSAOALVO, H.IDCRIARVERSAO,
           TO_CHAR(H.DTULTATU, 'DD/MM/YYYY HH24:MI:SS') AS DTULTATU
      FROM UPDATERHISTORICO H
      JOIN UPDATERPRODUTOS P ON P.ID = H.CDPRODUCTID
      JOIN FILIAL F ON F.CDFILIAL = H.CDFILIAL
     WHERE H.CDPRODUCTID = :CDPRODUCTID
       AND H.CDFILIAL = :CDFILIAL
  ORDER BY H.DTULTATU DESC
    `;

    const params = {
      CDPRODUCTID: cdProductId,
      CDFILIAL: cdFilial,
    }
    
    return OracleService.fetchAssoc(sql, params);
  }
}

module.exports = new updaterHistoricoModel();
